/***************************************************************************
                          main.c  -  description
                             -------------------
    begin                : Do Apr  8 16:08:23 CEST 2004
    copyright            : (C) 2004 by Arnold Schiller
    email                : schiller@babsi.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


 /* *
 * mp3tag -- extract MP3 tags
 *
 * To compile, just type: cc -o liste main.c
 *
 * Author:   Arnold Schiller <aschiller@easynet.de>
 * Created: 20 Oct 2003 , 18 Oct 2003
 * Version: $Id: mp3tag.c,v 1.1 2000/01/24 15:37:24 bbos Exp $
 * Changed: $Id: mp3tag.c,v 1.11 2003/10/18 14:06:55 aschiller Exp $
 *
 * Output changed <song><title>Titel...</song>
 *
 * Changed: $ID: mp3tag.c,v 1.12 2003/20/18 14:30:00 aschiller Exp $
 * case u....
 * HEXVALUE(c)
 * it is not realy UTF8-Conform ;-(
 * dirty - there must be a better way
 */
#include <unistd.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <ctype.h>

#define HEXVALUE(c)   (((c) >= 'a' && (c) <= 'f')   ? (c)-'a'+10   : (c) >= 'A' && (c) <= 'F' ? (c)-'A' - 10 : (c)-'0')
//a+10 A-10
typedef enum {Normal, Shell, CShell, Xml, Raw, Strip} Format;



const char *genres[] = {
"Blues", "Classic Rock", "Country", "Dance", "Disco", "Funk",
"Grunge", "Hip-Hop", "Jazz", "Metal", "New Age", "Oldies", "Other",
"Pop", "R&B", "Rap", "Reggae", "Rock", "Techno", "Industrial","Alternative", "Ska", "Death Metal", "Pranks", "Soundtrack",
"Euro-Techno", "Ambient", "Trip-Hop", "Vocal", "Jazz+Funk", "Fusion",
"Trance", "Classical", "Instrumental", "Acid", "House", "Game", "Sound Clip", "Gospel", "Noise", "AlternRock", "Bass", "Soul", "Punk",
"Space", "Meditative", "Instrumental Pop", "Instrumental Rock",
"Ethnic", "Gothic", "Darkwave", "Techno-Industrial", "Electronic",
"Pop-Folk", "Eurodance", "Dream", "Southern Rock", "Comedy", "Cult",
"Gangsta", "Top 40", "Christian Rap", "Pop/Funk", "Jungle", "Native American", "Cabaret", "New Wave", "Psychadelic", "Rave", "Showtunes",
"Trailer", "Lo-Fi", "Tribal", "Acid Punk", "Acid Jazz", "Polka",
"Retro", "Musical", "Rock'n Roll", "Hard Rock", "Folk", "Folk-Rock",
"National Folk", "Swing", "Fast Fusion", "Bebob", "Latin", "Revival",
"Celtic", "Bluegrass", "Avantgarde", "Gothic Rock", "Progressive Rock", "Psychedelic Rock", "Symphonic Rock", "Slow Rock", "Big Band",
"Chorus", "Easy Listening", "Acoustic", "Humour", "Speech", "Chanson",
"Opera", "Chamber Music", "Sonata", "Symphony", "Booty Bass",
"Primus", "Porn Groove", "Satire", "Slow Jam", "Club", "Tango",
"Samba", "Folklore", "Ballad", "Power Ballad", "Rhytmic Soul",
"Freestyle", "Duet", "Punk Rock", "Drum Solo", "Acapella",
"Euro-House", "Dance Hall", "Goa", "Drum and Bass", "Club-House",
"Hardcore", "Terror", "Indie", "BritPop", "Negerpunk", "Polsk Punk",
"Beat", "Christian Gangsta Rap", "Heavy Metal", "Black Metal",
"Crossover", "Contemporary Christian", "Christian Rock", "Merengue",
"Salsa", "Trash Metal", "Anime", "JPop", "SynPop", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown",
"Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown", "Unknown"};


/* syserr -- print s + system error message and exit */
static void syserr(const char *s)
{
  perror(s);
  exit(1);
}


/* out -- print a tag on stdout */
static void out(const char *label, const char *tag, size_t max, Format format)
{
  int i;

  switch (format) {
    case Normal:
      printf("\t%s\t", label);
      for (i = 0; i < max && tag[i]; i++) putchar(tag[i]);
      putchar('\n');
      break;
    case Shell:
      printf("export %s;\t%s=", label, label);
      for (i = 0; i < max && tag[i]; i++) {
	if (! isalnum(tag[i])) putchar('\\');
	putchar(tag[i]);
      }
      printf(";\n");
      break;
    case CShell:
      printf("setenv %s ", label);
      for (i = 0; i < max && tag[i]; i++) {
	if (! isalnum(tag[i])) putchar('\\');
	putchar(tag[i]);
      }
      printf(";\n");
      break;
    case Xml:
      printf("\t<%s>", label);
      for (i = 0; i < max && tag[i]; i++) {
           		 if(isspace(tag[i])){
					printf("&#x20;",tag[i]);
			 }else if(ispunct(tag[i])) {
			      			switch(tag[i]) {
			 				case '>': fputs("&gt;",stdout); break;
			 				case '<': fputs("&lt;",stdout); break;
			 				case '/': putchar(tag[i]); break;
			 				case '.': putchar(tag[i]); break;
                         				case '&': fputs("&#38;",stdout); break;
                         				case '_': putchar(tag[i]); break;
                         				default:
							    if(isprint(tag[i])) {
								printf("&#%u;",tag[i]);
								}
						}
			} else if(islower(tag[i])) {
					 putchar(tag[i]);
			} else if(isupper(tag[i])) {
					 putchar(tag[i]);
			} else if(isdigit(tag[i])){
			        	putchar(tag[i]);
			} else {
			        	switch(tag[i]) {
					         //
						//case 0x80 : fputs("&#161;" , stdout); break;
						//
						//case 0x81 : fputs("&#162;" , stdout); break;
						//case '' : fputs("&#163;" , stdout); break;
						//case '?' : fputs("&#164;" , stdout); break;
						//case '' : fputs("&#165;" , stdout); break;
						//case '?' : fputs("&#166;" , stdout); break;
						//case '' : fputs("&#167;" , stdout); break;
						//case '?' : fputs("&#168;" , stdout); break;
						case '' : fputs("&#169;" , stdout); break;
						//case '' : fputs("&#170;" , stdout); break;
						//case '' : fputs("&#171;" , stdout); break;
						//case '' : fputs("&#172;" , stdout); break;
						//case '' : fputs("&#173;" , stdout); break;
						//case '' : fputs("&#174;" , stdout); break;
						//case '' : fputs("&#175;" , stdout); break;
						//case '' : fputs("&#176;" , stdout); break;
						//case '' : fputs("&#177;" , stdout); break;
						//case '' : fputs("&#178;" , stdout); break;
						//case '' : fputs("&#179;" , stdout); break;
						//case '' : fputs("&#181;" , stdout); break;
						//case '' : fputs("&#182;" , stdout); break;
						//case '*' : fputs("&#183;" , stdout); break;
						//case '' : fputs("&#185;" , stdout); break;
						//case '' : fputs("&#186;" , stdout); break;
						//case '' : fputs("&#187;" , stdout); break;
						//case '' : fputs("&#191;" , stdout); break;
						case '' : fputs("&#192;" , stdout); break;
						case '' : fputs("&#193;" , stdout); break;
						case '' : fputs("&#194;" , stdout); break;
						case '' : fputs("&#195;" , stdout); break;
						case '' : fputs("&#196;" , stdout); break;
						case '' : fputs("&#197;" , stdout); break;
						case '' : fputs("&#198;" , stdout); break;
						case '' : fputs("&#199;" , stdout); break;
						case '' : fputs("&#200;" , stdout); break;
						case '' : fputs("&#201;" , stdout); break;
						case '' : fputs("&#202;" , stdout); break;
						case '' : fputs("&#203;" , stdout); break;
						case '' : fputs("&#204;" , stdout); break;
						case '' : fputs("&#205;" , stdout); break;
						case '' : fputs("&#206;" , stdout); break;
						case '' : fputs("&#207;" , stdout); break;
						case '' : fputs("&#208;" , stdout); break;
						case '' : fputs("&#209;" , stdout); break;
						case '' : fputs("&#210;" , stdout); break;
						case '' : fputs("&#211;" , stdout); break;
						case '' : fputs("&#212;" , stdout); break;
						case '' : fputs("&#213;" , stdout); break;
						case '' : fputs("&#214;" , stdout); break;
						//case '' : fputs("&#215;" , stdout); break;
						//case '' : fputs("&#216;" , stdout); break;
						case '' : fputs("&#217;" , stdout); break;
						case '' : fputs("&#218;" , stdout); break;
						case '' : fputs("&#219;" , stdout); break;
						case '' : fputs("&#220;" , stdout); break;
						//case '' : fputs("&#221;" , stdout); break;
						//case '' : fputs("&#222;" , stdout); break;
						case '' : fputs("&#223;" , stdout); break;
						case '' : fputs("&#224;" , stdout); break;
						case '' : fputs("&#225;" , stdout); break;
						case '' : fputs("&#226;" , stdout); break;
						case '' : fputs("&#227;" , stdout); break;
						case '' : fputs("&#228;" , stdout); break;
						case '' : fputs("&#229;" , stdout); break;
						case '' : fputs("&#230;" , stdout); break;
						case '' : fputs("&#231;" , stdout); break;
						case '' : fputs("&#232;" , stdout); break;
						case '' : fputs("&#233;" , stdout); break;
						case '' : fputs("&#234;" , stdout); break;
						case '' : fputs("&#235;" , stdout); break;
						case '' : fputs("&#236;" , stdout); break;
						case '' : fputs("&#237;" , stdout); break;
						case '' : fputs("&#238;" , stdout); break;
						case '' : fputs("&#239;" , stdout); break;
						case '' : fputs("&#240;" , stdout); break;
						case '' : fputs("&#241;" , stdout); break;
						case '' : fputs("&#242;" , stdout); break;
						case '' : fputs("&#243;" , stdout); break;
						case '' : fputs("&#244;" , stdout); break;
						case '' : fputs("&#245;" , stdout); break;
						case '' : fputs("&#246;" , stdout); break;
						//case '' : fputs("&#247;" , stdout); break;
						//case '' : fputs("&#248;" , stdout); break;
						case '' : fputs("&#250;" , stdout); break;
						//case '' : fputs("&#253;" , stdout); break;
						//case '' : fputs("&#254;" , stdout); break;
						//case '' : fputs("&#255;" , stdout); break;

						default:
						if(iscntrl(tag[i])){
							//delete
							}else{
						   putchar(HEXVALUE(tag[i]));
						}
					}
             }


	}
      printf("</%s>", label);
      putchar('\n');
      break;
    case Raw:
     for (i = 0; i < max && tag[i]; i++)  putchar(tag[i]);
      break;
    case Strip:
	for (i = 0; i < max && tag[i]; i++) {
		if(isspace(tag[i])){
					//printf("&#%u;",tag[i]);
					fputs("&#x20;",stdout);
			} else if(islower(tag[i])) {
					putchar(tag[i]);
			} else if(isupper(tag[i])) {
					putchar(tag[i]);
			} else if(ispunct(tag[i])) {
			      		switch(tag[i]) {
			 				case '>': fputs("&gt;",stdout); break;
			 				case '<': fputs("&lt;",stdout); break;
			 				case '/': putchar(tag[i]); break;
			 				case '.': putchar(tag[i]); break;
                         				case '&': fputs("&#38;",stdout); break;
                         				case '_': putchar(tag[i]); break;
                         				default:
								printf("&#%u;",tag[i]);
							}
			} else if(isdigit(tag[i])){
					putchar(tag[i]);
			} else {
			        	switch(tag[i]) {
				     		case '' : fputs("&#192;" , stdout); break;
						case '' : fputs("&#193;" , stdout); break;
						case '' : fputs("&#194;" , stdout); break;
						case '' : fputs("&#195;" , stdout); break;
						case '' : fputs("&#196;" , stdout); break;
						case '' : fputs("&#197;" , stdout); break;
						case '' : fputs("&#198;" , stdout); break;
						case '' : fputs("&#199;" , stdout); break;
						case '' : fputs("&#200;" , stdout); break;
						case '' : fputs("&#201;" , stdout); break;
						case '' : fputs("&#202;" , stdout); break;
						case '' : fputs("&#203;" , stdout); break;
						case '' : fputs("&#204;" , stdout); break;
						case '' : fputs("&#205;" , stdout); break;
						case '' : fputs("&#206;" , stdout); break;
						case '' : fputs("&#207;" , stdout); break;
						case '' : fputs("&#208;" , stdout); break;
						case '' : fputs("&#209;" , stdout); break;
						case '' : fputs("&#210;" , stdout); break;
						case '' : fputs("&#211;" , stdout); break;
						case '' : fputs("&#212;" , stdout); break;
						case '' : fputs("&#213;" , stdout); break;
						case '' : fputs("&#214;" , stdout); break;
						//case '' : fputs("&#215;" , stdout); break;
						//case '' : fputs("&#216;" , stdout); break;
						case '' : fputs("&#217;" , stdout); break;
						case '' : fputs("&#218;" , stdout); break;
						case '' : fputs("&#219;" , stdout); break;
						case '' : fputs("&#220;" , stdout); break;
						//case '' : fputs("&#221;" , stdout); break;
						//case '' : fputs("&#222;" , stdout); break;
						case '' : fputs("&#223;" , stdout); break;
						case '' : fputs("&#224;" , stdout); break;
						case '' : fputs("&#225;" , stdout); break;
						case '' : fputs("&#226;" , stdout); break;
						case '' : fputs("&#227;" , stdout); break;
						case '' : fputs("&#228;" , stdout); break;
						case '' : fputs("&#229;" , stdout); break;
						case '' : fputs("&#230;" , stdout); break;
						case '' : fputs("&#231;" , stdout); break;
						case '' : fputs("&#232;" , stdout); break;
						case '' : fputs("&#233;" , stdout); break;
						case '' : fputs("&#234;" , stdout); break;
						case '' : fputs("&#235;" , stdout); break;
						case '' : fputs("&#236;" , stdout); break;
						case '' : fputs("&#237;" , stdout); break;
						case '' : fputs("&#238;" , stdout); break;
						case '' : fputs("&#239;" , stdout); break;
						case '' : fputs("&#240;" , stdout); break;
						case '' : fputs("&#241;" , stdout); break;
						case '' : fputs("&#242;" , stdout); break;
						case '' : fputs("&#243;" , stdout); break;
						case '' : fputs("&#244;" , stdout); break;
						case '' : fputs("&#245;" , stdout); break;
						case '' : fputs("&#246;" , stdout); break;
						//case '' : fputs("&#247;" , stdout); break;
						//case '' : fputs("&#248;" , stdout); break;
						case '' : fputs("&#250;" , stdout); break;
						//case '' : fputs("&#253;" , stdout); break;
						//case '' : fputs("&#254;" , stdout); break;
						//case '' : fputs("&#255;" , stdout); break;

						default:
						 putchar(HEXVALUE(tag[i]));

					}

		        }
	         }

      break;
    default:
      assert(!"Cannot happen");
  }
}


/* mp3tag -- get MP3 tags from a file and print them on stdout */
static void mp3tag(const char *filename, Format format)
{
  FILE *f;
  struct {
    char tag[3];				/* = "TAG" */
    char title[30];
    char artist[30];
    char album[30];
    char year[4];
    char comment[30];
    unsigned char genre;
  } info;
  if (! (f = fopen(filename, "r"))) syserr(filename);
  if (fseek(f, -128, SEEK_END) < 0) syserr(filename);
  if (fread(&info, sizeof(info), 1, f) != 1) syserr(filename);
  /* For XML-Format <song> */
    	if(format == Xml) {
		fputs("<song file=\"",stdout);
		out("",filename,strlen(filename),Strip);
		fputs("\">\n",stdout);
		}
  if (strncmp(info.tag, "TAG", 3) == 0) {

    out("name", filename, strnlen(filename), format);
    out("title", info.title, sizeof(info.title), format);
    out("artist", info.artist, sizeof(info.artist), format);
    out("album", info.album, sizeof(info.album), format);
    out("year", info.year, sizeof(info.year), format);
    out("comment", info.comment, sizeof(info.comment), format);
    out("genre", genres[info.genre], strlen(genres[info.genre]), format);

	}
     /* At the end a closed </song> */
       if(format == Xml){
		 fputs("</song>\n",stdout);
		}
}


/* usage -- print usage message and exit */
static void usage(const char *progname)
{
  fprintf(stderr, "Usage: %s [-s|-c|-x] mp3file\n", progname);
  exit(1);
}

static void help(const char *progname){
   fprintf(stderr, "Help:  \n\t-s for Bash-Output\n\t-c for CShell-Output\n\t-x XML-Output\n\t-h This message, try %s file.mp3\n", progname);

}

int main(int argc, char *argv[])
{
  Format format = Normal;
  int c, i , x , h;

  while ((c = getopt(argc, argv, "scxhr")) != -1) {
    switch (c) {
      case 's':	format = Shell; break;		/* Output for (Bourne) sh */
      case 'c':	format = CShell; break;		/* Output for Csh */
      case 'x': format = Xml; break;		/* XML output */
      case 'r': format = Raw; break;
      case 'h': help(argv[0]); break;		/* Display a short help */
      default: usage(argv[0]); break;
    }
  }
  if (optind == argc) usage(argv[0]);
  for (i = optind; i < argc; i++) mp3tag(argv[i], format);
  return 0;
}
